package Luokat;

public class Saalis {
    private static int saaliinId = 0;
    private final String koko;
    private final String laji;
    private int reissunTagi;

    /**
     * muodostin merkkijono taulukosta, tarvitaan saaliin muodostamiseen tiedostosta
     * @param rivi mitä tietoja saaliin muodostamiseen tarvitaan
     */
    public Saalis(String rivi) {
        String[] tiedot = rivi.split("\\|");
        int[] tiedotLuku = new int[tiedot.length];
        for (int i = 0; i < tiedotLuku.length; i++) {
            tiedotLuku[i] = Integer.parseInt(tiedot[i]);
        }
        LajiTulkki l = new LajiTulkki();
        laji = l.getLajiFromId(tiedotLuku[1]);
        KokoTulkki k = new KokoTulkki();
        koko = k.getKokoFromId(tiedotLuku[2]);
        reissunTagi = tiedotLuku[3];
        saaliinId++;
    }

    /**
     * muodostin suoraan arvoista
     * @param koko saaliin koko
     * @param laji saaliin laji
     */
    public Saalis(String koko, String laji) {
        this.koko = koko;
        this.laji = laji;
        saaliinId++;
    }

    public void setReissunTagi(int reissunTagi) {
        this.reissunTagi = reissunTagi;
    }

    /**
     * Tarvittavat getterit jokanen tekee sen mitä nimi sanoo
     * @return jonkin attribuuttinsa
     */
    public String getKoko() {
        return koko;
    }

    public String getLaji() {
        return laji;
    }
    public int getReissunTagi() {
        return reissunTagi;
    }

    public int getSaaliinId() {
        return saaliinId;
    }

    public String tiedotTallenusMuodossa(){
        LajiTulkki l = new LajiTulkki();
        int lajiId =  l.getIdFromLaji(laji);
        KokoTulkki k = new KokoTulkki();
        int kokoId = k.getIdFromKoko(koko);
        return saaliinId + "|" + lajiId + "|" +kokoId + "|" + reissunTagi;
    }

    /*
    pieni testi ohjelma
     */
    public static void main(String[] args) {
        String rivi = "1|1|3|1";
        Saalis s = new Saalis(rivi);
        System.out.println("------------Saaliin testi------------");
        System.out.println("tiedot annettu muodossa " + rivi);
        System.out.println(s.getKoko());
        System.out.println(s.getLaji());
        System.out.println(s.getReissunTagi());
        System.out.println(s.getSaaliinId());
        System.out.println(s.tiedotTallenusMuodossa());
    }

}
